var ParticleUtil = function() {

};

ParticleUtil.prototype = {

    initParticles: function() {
        this.particlesGroup = game.add.group();

        // var btmp = game.add.bitmapData(1, 1);
        // btmp.fill(0xff,0xff,0xff, 1);
        // game.cache.addBitmapData('particccle', btmp);
    },

    fireParticle: function(x, y, count, scaleFunc) {
        if (count == undefined) count = 1;
        for (var i = 0; i < count; i++) {
            if (this.particlesGroup.countLiving() > 40) {
                return;
            }

            var spriteToReturn = this.particlesGroup.getFirstDead();

            if (spriteToReturn == null) {
                spriteToReturn = this.particlesGroup.create(0, 0, 'imgpk', 'win_particle_star1');
                setObjectAnchor(spriteToReturn, 0.5, 0.5);
                game.physics.enable(spriteToReturn, Phaser.Physics.ARCADE);
            }

            spriteToReturn.reset(x, y);

            spriteToReturn.angle = Math.floor(Math.random() * 90) - 45;
            // spriteToReturn.lifespan = 2500;
            spriteToReturn.rotateStep = Math.floor(Math.random() * 200) / 10 - 10;

            if (scaleFunc !== undefined) spriteToReturn.scale.set(scaleFunc());
            spriteToReturn.angle = Math.floor(Math.random() * 360);

            spriteToReturn.allowGravity = true;
            // spriteToReturn.tint = tint;
            //spriteToReturn.body.gravity.y = 550 + Math.floor(Math.random() * 200);
            spriteToReturn.body.gravity.y = 300 + Math.floor(Math.random() * 800);
            var ra1 = (Math.floor((Math.random() * 15) + 1)) * 25;
            spriteToReturn.body.velocity.y = -ra1;
            var ra = Math.floor((Math.random() * 300)) - 150;
            spriteToReturn.body.velocity.x = ra;

            spriteToReturn.revive();
        }
    },

    updateParticles: function() {
        this.particlesGroup.forEachAlive(function(particle) {
            particle.angle += particle.rotateStep;

            if (particle.y - 30 > game.height) particle.kill();
        }, this);
    }
}